::checks if started as admin, if so add wdp, add apppool and set apppool
@echo off

:: ---------------------------------------------------------------------------------
:: local used variables
:: ---------------------------------------------------------------------------------
set _AppName="Default Web Site/barcodeservice"
set _AppPool="TEC-IT"
set _Destination=auto
set RootPath=%~dp0
set MSDeployPath=
:: ---------------------------------------------------------------------------------
:: check for admin rights
:: ---------------------------------------------------------------------------------
net session >nul 2>&1
if NOT %errorLevel% == 0 (
  echo Failure: Administrative permissions needed!
  pause
  goto :eof
)

:: ---------------------------------------------------------------------------------
:: if user does not set MsDeployPath environment variable, we will try to retrieve it from registry.
:: ---------------------------------------------------------------------------------
if "%MSDeployPath%" == "" (
for /F "usebackq tokens=1,2,*" %%h  in (`reg query "HKLM\SOFTWARE\Microsoft\IIS Extensions\MSDeploy" /s  ^| findstr -i "InstallPath"`) do (
if /I "%%h" == "InstallPath" ( 
if /I "%%i" == "REG_SZ" ( 
if not "%%j" == "" ( 
if "%%~dpj" == "%%j" ( 
set MSDeployPath=%%j
))))))

if not exist "%MSDeployPath%msdeploy.exe" (
  echo msdeploy.exe was not found on this machine. Please install Web Deploy before executing this script. 
  echo Please visit http://go.microsoft.com/?linkid=9278654
  pause
  goto :eof
)

:: ---------------------------------------------------------------------------------
:: check the existence of the package file
:: ---------------------------------------------------------------------------------
if not exist "%RootPath%BarcodeService.zip" (
  echo "%RootPath%BarcodeService.zip" does not exist. 
  echo This batch file relies on this deploy source file^(s^) in the same folder.
  pause
  goto :eof
)


:: ---------------------------------------------------------------------------------
:: check for parameters
:: ---------------------------------------------------------------------------------
IF "%~1"=="" GOTO HAVE_0
IF "%~2"=="" GOTO HAVE_1
IF "%~3"=="" GOTO HAVE_2

:: ---------------------------------------------------------------------------------
:: no parameters - use default
:: ---------------------------------------------------------------------------------
:HAVE_0
echo Installation with default values (app.name: %_AppName%, app.pool: %_AppPool%)
goto :install       


:: ---------------------------------------------------------------------------------
:: only one parameters - error
:: ---------------------------------------------------------------------------------        
:HAVE_1
echo Failure: insufficient parameters!
goto :usage


:: ---------------------------------------------------------------------------------
:: both parameters set
:: ---------------------------------------------------------------------------------        
:HAVE_2
  echo App.name is set to: %1
  set _AppName=%1
  echo applicationPool is set to: %2
  set _AppPool=%2
  goto :install      
      
            

:: ---------------------------------------------------------------------------------
:: start msdeploy.exe with given parameter
:: --------------------------------------------------------------------------------- 
:install
echo Start msdeploy.exe
call "%MSDeployPath%msdeploy.exe" -source:package='%RootPath%BarcodeService.zip' -dest:%_Destination% -verb:sync -disableLink:AppPoolExtension -disableLink:ContentExtension -disableLink:CertificateExtension -skip:objectname='dirPath',absolutepath='obj\\Release\\Package\\PackageTmp\\App_Data$' -skip:objectname='dirPath',absolutepath='Default\ Web\ Site/barcodeservice\\App_Data$' -setParam:"IIS Web Application Name"=%_AppName%
::add apppool param %2
echo Add new Application Pool %_AppPool%
call "%windir%\system32\inetsrv\appcmd" add apppool /name:%_AppPool%
::move barcodeservice in apppool TEC-IT
echo Move %_AppName% to %_AppPool% 
call "%windir%\system32\inetsrv\appcmd" set app /app.name:%_AppName% /applicationPool:%_AppPool%
echo Installation completed
pause
goto :eof

:usage
echo Usage:%~nx0 [IIS Web Application Name ^& Application Pool]
echo For more information about this batch file, see documentation TBarCode_BarcodeServices.pdf
pause
goto :eof
:eof